-- Standard Library ... by Aku 2000-2003

include graphics.e
include get.e
include machine.e
include dll.e
include wildcard.e
include file.e
            
object tp, tp2

global object pppath
if platform() = 3 then pppath = '/' else pppath = '\\' end if
 -------- 23

-- hapus console yang ga perlu!!!
object hapuscon_kernel32,
       hapuscon_freeconsole,
       hapuscon_tp
if platform() = 2 then
	hapuscon_kernel32 = open_dll("kernel32.dll")
	hapuscon_freeconsole = define_c_func(hapuscon_kernel32, "FreeConsole", {}, C_LONG)
	hapuscon_tp = c_func(hapuscon_freeconsole, {})
end if
 
 
global function timer()
    if platform() = 2 then
        return (c_func(define_c_func(open_dll("kernel32.dll"), "GetTickCount", {}, C_LONG), {})/1000)
    else
        return time()
    end if
end function
--67
---------23
global function left(sequence st, atom terkiri)
    if terkiri >= length(st) then
        return st
    else
        return st[1..terkiri]
    end if
end function

global function mid(sequence st, atom mulai, atom banyak)
    if mulai > length(st) then
        return ""
    elsif banyak = 0 or banyak <= -2 then
        return ""
    elsif mulai+banyak-1 > length(st) then
        return st[mulai..length(st)]
    elsif banyak = -1 then
        return st[mulai..length(st)]
    elsif banyak+mulai-1 < 0 then
        return ""
    elsif mulai < 1 then
        return st[1..banyak+mulai-1]
    else
        return st[mulai..banyak+mulai-1]
    end if
end function



global function Mid(sequence st, atom mulai, atom banyak)
    return mid(st, mulai, banyak)
end function                     

global function right(sequence st, atom terkanan)
    if terkanan >= length(st) then
        return st
    else
        return st[length(st)-terkanan+1..length(st)]
    end if
end function

global function palet(atom kodewarna, sequence rgb)
    tp=palette(kodewarna, rgb)
    return 1
end function

global function p(sequence seq)
    return length(seq)
end function

global function tunggu_pencet(atom bataswaktu, atom kalonggak)
    tp=timer()
    while timer()-tp < bataswaktu do
        tp2 = get_key()
        if tp2 != -1 then
            return tp2
        end if
    end while
    return kalonggak
end function

global procedure bobo(atom waktums)
    tp=timer()
    while 1 do
        if timer()-tp >= (waktums/1000) then
            exit
        end if
    end while
end procedure

global function asc(sequence st)
    return st[1]
end function

global function Asc(sequence st)
    return asc(st)
end function

global function sisa(atom dibagi, atom pembagi)
    if dibagi >= 0 then
        return remainder(dibagi+pembagi, pembagi)
    else
        return remainder(dibagi, pembagi)
    end if
end function

global function byteAja(atom a)
	return and_bits(a, #FF)
end function

--global function int(atom no)
--    return floor(no)
--end function

global function Int(atom no)
    return floor(no)
end function

global function hex(atom no)
    sequence b --balik

    b=repeat(0,8)
    
    for i= 8 to 1 by -1 do
        b[i] = remainder(no + 16, 16)
        no=floor(no/16)
    end for
    
    for i=1 to length(b) do
        if b[i] >= 10 then
            b[i] = b[i]+55
        elsif b[i] >= 1 then
            b[i] = b[i]+48
        elsif b[i] = 0 then
            b[i] = 48
        end if
    end for               
    
    while b[1]='0' do
        if length(b)!=1 then
            for i=1 to length(b)-1 do
                b[i]=b[i+1]
            end for
        else
            exit
        end if
        b = b[1..length(b)-1]
    end while

    return b

end function

global function Hex(atom no)
    return hex(no)
end function

global function hex2(atom no)
    sequence tp
    tp=repeat(0,2)
    tp[2]=remainder(no+16,16)
    no = floor(no/16)
    tp[1]=no
    
    for i=1 to 2 do
        if tp[i]>=0 and tp[i]<=9 then
            tp[i] = tp[i]+48
        else
            tp[i] = tp[i]+55
        end if
    end for
    return tp
end function

global function val(sequence st)
object tp
    tp = value(st)
    return tp[2]
end function

global function eqv_bits(atom a, atom b)
    sequence abit, bbit, tp
    
    abit=int_to_bits(a, 8)
    bbit=int_to_bits(b, 8)
    tp=repeat(0,8)
    
    for i=1 to length(abit) do
        if abit[i]=bbit[i] then
            tp[i]=1
        else
            tp[i]=0
        end if
    end for        
    
    return bits_to_int(tp)
    
end function

global function instr(atom mulai, sequence st1, sequence st2)
atom aku_instr_di
    if mulai > length(st1) then
        return 0
    elsif compare(st2, {})=0 then
        return 1
    elsif length(st2) > length(st1) then
        return 0
    elsif length(st1) = length(st2) then
        return compare(st1, st2)=0
    else
        aku_instr_di = match(st2, st1[mulai..length(st1)])
        if aku_instr_di then
            return aku_instr_di + mulai - 1
        else
            return 0
        end if
    end if
end function

global function dlmst(atom mulai, sequence st1, sequence st2)
-- huruf kecil dan besar disamain
    return instr(mulai, lower(st1), lower(st2))
end function

global function pisah(sequence st, atom pemisah)
    sequence hasil
    atom posHasil
    hasil={}
    posHasil=1
    
    for i=1 to length(st) do
        if st[i]=pemisah then
            posHasil = posHasil+1
        end if
            
        while 1 do
            if length(hasil)<posHasil then
                hasil = append(hasil, {})
            else
                exit
            end if
        end while   
        
        if st[i]!=pemisah then
            hasil[posHasil] = hasil[posHasil]&st[i]
        end if

    end for
    
    return hasil
    
end function

global function pisah2(sequence st, sequence pemisah)
    sequence hasil
    object pos
    hasil={}
    
    while 1 do
        pos = match(pemisah,st)
        if pos then
            hasil = append(hasil, st[1..pos-1])
            st = st[pos+length(pemisah)..length(st)]
        else
            exit
        end if
    end while
       hasil = append(hasil, st)
    
    return hasil
end function


global function depisah(object st, object pemisah)
object balik
    balik = ""
    for i=1 to length(st)-1 do
        balik &= st[i] & pemisah
    end for
    balik &= st[length(st)]
    return balik
end function

global function no10(object baris)
    if atom(baris) then
        return -1
    elsif length(baris) = 0 then 
        return baris
    elsif baris[length(baris)]=10 or baris[length(baris)]=13 then
        return baris[1..length(baris)-1]
    else
        return baris
    end if
end function

global function buangkosong(sequence dt)
sequence hasil
    hasil={}
    
    for i=1 to length(dt) do
        if compare(dt[i],{})=0 then
        else
            hasil = append(hasil, dt[i])
        end if
    end for                             
    
    return hasil
end function

global function kalo(atom syarat, object betul, object salah)
    if syarat then
        return betul
    else
        return salah
    end if
end function

global procedure winpalingatas(atom handel)
tp = open_dll("user32.dll")
tp = define_c_func(tp, "SetWindowPos", {C_POINTER, C_POINTER, C_INT, C_INT, C_INT, C_INT, C_UINT}, C_LONG)
tp = c_func(tp, {handel, -1, 0, 0, 0, 0, 3})
end procedure

global procedure winnggakpalingatas(atom handel)
tp = open_dll("user32.dll")
tp = define_c_func(tp, "SetWindowPos", {C_POINTER, C_POINTER, C_INT, C_INT, C_INT, C_INT, C_UINT}, C_LONG)
tp = c_func(tp, {handel, 0, 0, 0, 0, 0, 3})
end procedure

global function ganti(sequence st, sequence dicari, sequence pengganti)
atom pos, a
    pos = 1
    
    while 1 do
        a = instr(pos, st, dicari)
        if a=0 then exit end if
        st = st[1..a-1] & pengganti & st[length(dicari)+a..length(st)]
        pos = a+length(pengganti)
    end while
    
    return st
end function

global procedure pc(object apapun) -- func2proc
    if object(apapun) then end if
end procedure

global function bag(object st, atom i)
    if atom(st) then return st end if
    return st[i]
end function

global function syuhyangsama(object kt)
object tanda, hasil
	tanda = repeat(1, length(kt))
	for i = 1 to length(kt)-1 do
		for j = i+1 to length(kt) do
			if equal(kt[i], kt[j]) then
				tanda[j] = 0
			end if
		end for
	end for
	hasil = {}
	for i = 1 to length(tanda) do
		if tanda[i] then
			hasil = append(hasil, kt[i])
		end if
	end for
	return hasil
end function

global function filelen(sequence st)
object hasildir
    hasildir = dir(st)
    if atom(hasildir) or length(hasildir) = 0 then
        return -1
    end if
    return hasildir[1][3]
end function

global function isst(object ob)
    if sequence(ob) then
        for i=1 to length(ob) do
            if sequence(ob[i]) then
                return 0
            else
            	if (ob[i] >= 32 and ob[i] <= 255) or find(ob[i], "\n\r\t ") then
            	else
            		return 0
            	end if
            end if
        end for
        return 1
    else
        return 0
    end if
end function


object euob_hasil
euob_hasil = 0

procedure aturEuobSt(object ob)
	euob_hasil &= "\""
	for i = 1 to length(ob) do
		if ob[i] = '\t' then
			euob_hasil &= "\\t"
		elsif ob[i] = '\n' then
			euob_hasil &= "\\n"
		elsif ob[i] = '\r' then
			euob_hasil &= "\\r"
		elsif ob[i] = '"' then
			euob_hasil &= "\\\""
		elsif ob[i] = '\'' then
			euob_hasil &= "\\'"
		elsif ob[i] = '\\' then
			euob_hasil &= "\\\\"
		else
			euob_hasil &= ob[i]
		end if
	end for
	euob_hasil &= "\""
end procedure

global procedure xeuob(object ob)
    if atom(ob) then
        euob_hasil &= sprintf("%.10g", ob)
    elsif isst(ob) then
        aturEuobSt(ob)
    else
        euob_hasil &= "{"
        for i = 1 to length(ob) do
        	xeuob(ob[i])
        	if i != length(ob) then
        		euob_hasil &= ", "
        	end if
        end for
        euob_hasil &= "}"
    end if
end procedure

global function euob(object ob)
	euob_hasil = ""
	xeuob(ob)
	return euob_hasil
end function



global function tlb(object ob)
    if atom(ob) then
        return sprintf("%.10g", ob)
    elsif isst(ob) then
        return ob
    else
        return euob(ob)
    end if
end function

global procedure tl(object ob)
    puts(1, tlb(ob))
end procedure

global procedure tln(object ob)
    puts(1, tlb(ob))
    puts(1, "\n")
end procedure


global procedure tf(atom fn, object ob)
    puts(fn, tlb(ob))
end procedure

global procedure tfn(atom fn, object ob)
    puts(fn, tlb(ob))
    puts(fn, "\n")
end procedure

global function isist(object tanya)
object tp
    tl(tanya)
    tp = gets(0)
    tl("\n")
    if isst(tp) then
        return no10(tp)
    else
        return ""
    end if
end function

global function isino(object tanya)
object tp, tp2
    
    while 1 do
        tl(tanya)
        tp = no10(gets(0))
        tl("\n")
    
        tp2 = value(tp)
        if tp2[1] = GET_SUCCESS then
            if atom(tp2[2]) then
                exit
            end if
        end if
    end while
    
    return tp2[2]
end function

global procedure tlx(object ob)
    tln(ob)
    pc(getc(0))
    abort(1)
end procedure

global function stambah(integer di, object ob, object isi)
    ob &= 0
    ob[di+1..length(ob)] = ob[di..length(ob)-1]
    ob[di] = isi
    return ob
end function

global function skurang(object di, object ob)
    if atom(di) then di = {di,di} end if
    ob = ob[1..di[1]-1] & ob[di[2]+1..length(ob)]
    return ob
end function

global function skosong(object st)
	if sequence(st) then
		return length(st) = 0
	else
		tln("skosong: st bukan sequence")
		return st
	end if
end function

global function syuhurut(object ob)
object daftarsyuh
    daftarsyuh = {}
    for i=1 to length(ob)-1 do
        if equal(ob[i], ob[i+1]) then
            daftarsyuh &= i
        end if
    end for
    for i=length(daftarsyuh) to 1 by -1 do
        ob = skurang(daftarsyuh[i], ob)
    end for
    return ob
end function

global function syuhuruthanya(object ob, object hanya)
object daftarsyuh
    daftarsyuh = {}
    for i=1 to length(ob)-1 do
        if equal(ob[i], ob[i+1]) then
            if equal(ob[i], hanya) then
                daftarsyuh &= i
            end if
        end if
    end for
    for i=length(daftarsyuh) to 1 by -1 do
        ob = skurang(daftarsyuh[i], ob)
    end for
    return ob
end function

global function acakurut(object s)
    object temp
    integer j

    for i = length(s) to 2 by -1 do
        j = rand(i)
        temp = s[j]
        s[j] = s[i]
        s[i] = temp
    end for
    return s
end function

global function ambilfile(object file)
object fn, balik, kar, len
    if sequence(file) then
    	len = filelen(file)
    	if len = 0 then
    		return ""
    	elsif len < 0 then
    		return -1
    	end if
        balik = repeat(0, len)
        fn = open(file, "rb")
        if fn <0 then return -1 end if
        
        for i = 1 to len do
            balik[i] = getc(fn)
        end for
        close(fn)
        return balik
    else
        balik = ""
        while 1 do
            kar = getc(file)
            if kar != -1 then
                balik &= kar
            else
                exit
            end if
        end while
        return balik
    end if
end function

global function iskeyword(object st)
	if length(st)=0 then return 0 end if
    if (st[1] >= 'a' and st[1] <= 'z') or (st[1] >= 'A' and st[1] <= 'Z') then
        for i=2 to length(st) do
            if (st[i] >= 'a' and st[i] <= 'z') or (st[i] >='A' or st[i] <= 'Z') or (st[i] >='0' or st[i] <= '9') or st[i] = '_' then
            else
                return 0
            end if
        end for
        return 1
    else
        return 0
    end if
end function

global function carisemua(object dicari, object st)
object balik
    balik = {}
    for i=1 to length(st) do
        if equal(dicari, st[i]) then
            balik &= i
        end if
    end for
    return balik
end function

global function jawabya(object st)
object jwb
    jwb = lower(isist(st))
    if find(jwb, {"y", "ya", "yes", "ok", "oke", "iya", "iyah", "ia", "yah", "yu"}) then
        return 1
    else
        return 0
    end if
end function

global function pathfile(object st)
object ppdi, ppdi2
	st = reverse(st)
	ppdi = find('\\', st)
	ppdi2 = find('/', st)
	if ppdi=0 and ppdi2=0 then
		return reverse(st)
	elsif ppdi=0 then
		return reverse(st[ppdi2+1..length(st)])
	elsif ppdi2=0 then
		return reverse(st[ppdi+1..length(st)])
	elsif ppdi < ppdi2 then
		return reverse(st[ppdi+1..length(st)])
	elsif ppdi2 <= ppdi then
		return reverse(st[ppdi2+1..length(st)])
	end if
end function

global function pathfileLAMA(object st)
object ppdi
    if find(pppath, st) = 0 then
        return ""
    else
        ppdi = carisemua(pppath, st)
        return st[1..ppdi[length(ppdi)]-1]
    end if
end function

global function namafile(object st)
object ppdi, ppdi2
	st = reverse(st)
	ppdi = find('\\', st)
	ppdi2 = find('/', st)
	if ppdi=0 and ppdi2=0 then
		return reverse(st)
	elsif ppdi=0 then
		return reverse(st[1..ppdi2-1])
	elsif ppdi2=0 then
		return reverse(st[1..ppdi-1])
	elsif ppdi < ppdi2 then
		return reverse(st[1..ppdi-1])
	elsif ppdi2 <= ppdi then
		return reverse(st[1..ppdi2-1])
	end if
end function

global function ambilbaris(object file)
object x, hasil, y
    hasil = {}
    x = open(file, "r")
    while 1 do
        y = no10(gets(x))
        if atom(y) then
            exit
        end if
        if length(y) then
        	hasil = append(hasil, y)
        end if
    end while
    close(x)
    return hasil
end function

global procedure tulisbaris(object file, object tulisan)
object x
    x = open(file, "w")
    for i=1 to length(tulisan) do
        puts(x, tulisan[i])
        puts(x, "\n")
    end for
    close(x)
end procedure

global procedure tulisfile(object file, object isi)
object fn
    fn = open(file, "wb")
    if fn=-1 then return end if
    puts(fn, isi)
    close(fn)
end procedure

global function antara(object x, object ba, object bb)
    if x >= ba and x <= bb then
        return 1
    else
        return 0
    end if
end function

global function valsampe(object st)
object v, y
    v = ""
    y = 0
    for i=1 to length(st) do
        if find(st[i], "0123456789") then
            v &= st[i]
            y = i
        else
            exit
        end if
    end for
    return {val(v),y}
end function

global function adafile(object fil)
object dirfil
	dirfil = dir(fil)
    if sequence(dirfil) then
        if find('d', dirfil[1][2]) then
            return 0
        else
            return 1
        end if
    else
        return 0
    end if

end function

global function atribFile(object fil)
object dirfil
	dirfil = dir(fil)
    if sequence(dirfil) then
        return dirfil[1][2]
    else
        return -1
    end if
end function

global function gabungpath(object path, object nama)
    if length(path) = 0 then return nama end if
    if path[length(path)] = pppath then
        path = path[1..length(path)-1]
    end if
    if length(nama) = 0 then return path end if
    if nama[1] = pppath then
        nama = nama[2..length(nama)]
    end if
    return path & pppath & nama
end function

global function ulangst(object st, object sebanyak)
object hasil
    hasil = ""
    for i=1 to sebanyak do
        hasil &= st
    end for
    return hasil
end function

global function pertamaditemukan(atom mulai, object st, object dicarisalahsatu)
    for i=mulai to length(st) do
        if find(st[i], dicarisalahsatu) then
            return i
        end if
    end for
    return 0
end function

global function sampaitutup(atom mulai, object st, object pembuka, object penutup)
object dalam
    dalam = 0
    for i=mulai to length(st) do
        if find(st[i], pembuka) then
            dalam += 1
        end if
        if find(st[i], penutup) then
            dalam -= 1
        end if
        if dalam = 0 then
            return i
        end if
    end for
    return 0
end function

global function vfind(object dicari, object carian, object kolomke)
    for i=1 to length(carian) do
        if equal(dicari, carian[i][kolomke]) then
            return i
        end if
    end for
    return 0
end function

global function getx(integer fn, integer n)
-- Return a sequence of n bytes (maximum) from an open file.
-- If n > 0 and fewer than n bytes are returned, 
-- you've reached the end of file.
sequence s
integer c

    if n = 0 then
        return {}
    end if
    
    c = getc(fn)
    
    if c = -1 then
        return {}
    end if
    
    s = repeat(c, n)
    
    for i = 2 to n do
        s[i] = getc(fn)
    end for
    
    if s[n] != -1 then
        return s
    else
        -- trim eof's
        while s[n] = -1 do
            n -= 1
        end while
        return s[1..n]
    end if
end function

global function sampai0(object st)
object x
    x = find(0, st)
    if x then
        return st[1..x-1]
    else
        return st
    end if
end function

global function hexString(object st)
object x
    x = repeat('0', length(st)*2)
    for i = 1 to length(st) do
        x[(i-1)*2+1 .. (i-1)*2+2] = sprintf("%02x", st[i])
    end for
    return x
end function

function hex2dec(object x)
	if x <= '9' then
		return x-'0'
	else
		return x-'A'+10
	end if
end function

global function stringHex(object st)
object x
	x = repeat(0, floor(length(st)/2+0.1))
	for i=1 to length(st) by 2 do
		x[(i+1)/2] = hex2dec(st[i])*16+hex2dec(st[i+1])
	end for
	return x
end function

global function bke2(object x, object y)
    return reverse(int_to_bits(x,y))
end function

global function b2ke(object b2)
    return bits_to_int( reverse(b2) )
end function

global function ambilBarisBetul(object teks)
object b, h
    teks = ganti(teks,"\r\n","\n")
    teks = ganti(teks,"\r","\n")
    b = pisah(teks, '\n')
    h = {}
    for i=1 to length(b) do
        if length(b[i]) then
            h = append(h, b[i])
        end if
    end for
    return h
end function

global function buangPinggirKosong(object st)
object p
	p = 0
	for i = 1 to length(st) do
		if find(st[i], "\n\r\t ") then
			p = i
		else
			exit
		end if
	end for
	st = st[p+1..length(st)]
	p = length(st)+1
	for i = length(st) to 1 by -1 do
		if find(st[i], "\n\r\t ") then
			p = i
		else
			exit
		end if
	end for
	st = st[1..p-1]
	return st
end function

global function tanpaExt(object nf)
object p
	p = length(nf)+1
	for i=1 to length(nf) do
		if nf[i] = '.' then
			p = i
		end if
	end for
	return nf[1..p-1]
end function

global function dariKanan(sequence st, integer x)
	if x <= 0 then
		return st
	elsif x > length(st) then
		return {}
	else
		return st[1..length(st)-x]
	end if
end function

object aku_getval_tp
global function getval(object fn)
	aku_getval_tp = get(fn)
	return aku_getval_tp[2]
end function

global function mutlak(object x)
	return ((x>0)*2-1) * x
end function

global function spasiSisa(object max, object udah)
	return repeat(' ', kalo(max-udah < 0, 0, max-udah))
end function

global function banyaknya(object sq, object x)
object hit
	hit = 0
	for i = 1 to length(sq) do
		if equal(x, sq[i]) then
			hit += 1
		end if
	end for
	return hit
end function

constant log_dari_10 = log(10)
global function log10(object wow)
	return log(wow) / log_dari_10
end function

global function jumlah(object x)
object j
	j = 0
	if atom(x) then 
		return x
	else
		for i = 1 to length(x) do
			if atom(x[i]) then
				j += x[i]
			else
				j += jumlah(x[i])
			end if
		end for
		return j
	end if
end function

global function selisih(object x, object y)
object z
	z = x-y
	if z > 0 then return z else return -z end if
end function

global procedure matte()
object x
	x = getc(0)
end procedure

global function banyakElemen(object ob)
object hs
	hs = 0
	if atom(ob) then
		return 1
	else
		for i = 1 to length(ob) do
			if atom(ob[i]) then
				hs += 1
			else
				hs += banyakElemen(ob[i])
			end if
		end for
	end if
	return hs
end function



global function ssum(object s)
object hs
	if atom(s) then
		return s
	else
		hs = 0
		for i = 1 to length(s) do
			hs += ssum(s[i])
		end for
	end if
	return hs
end function

global function smax(object s)
object maxi, maxn
	maxi = 0
	maxn = -9e999
	
	for i = 1 to length(s) do
		if s[i] > maxn then
			maxn = s[i]
			maxi = i
		end if
	end for
		
	return maxi
end function

global function smin(object s)
object mini, minn
	mini = 0
	minn = 9e999
	
	for i = 1 to length(s) do
		if s[i] < minn then
			minn = s[i]
			mini = i
		end if
	end for
		
	return mini
end function

global function ambilcsv(object nf, object pemisah)
object hs
	hs = ambilbaris(nf)
	for i = 1 to length(hs) do
		hs[i] = pisah(hs[i], pemisah)
	end for
	return hs
end function

global function isKosong(object char)
	return (find(char, " \r\n\t") > 0)
end function

global function pisahKata(object st)
object hasil, kata
	hasil = {}
	kata = ""
	for i = 1 to length(st) do
		if isKosong(st[i]) then
			if length(kata) then
				hasil = append(hasil, kata)
				kata = ""
			end if
		else
			kata &= st[i]
		end if
	end for
	if length(kata) then
		hasil = append(hasil, kata)
	end if
	return hasil
end function

global function tambahExtKaloBelum(object nf, object ext, object paksaGanti)
	if not paksaGanti then
		if find('.', namafile(nf)) then -- udah ada ext lain
			return nf
		else
			return nf & "." & ext
		end if
	else
		if dlmst(1, right(nf, length(ext)+1), "." & ext) then
			nf = mid(nf, 1, length(nf)-length(ext)-1)
		end if
		return nf & "." & ext
	end if
end function

global function bacaPtrString(object ptr)
object st, ch
	st = ""
	if ptr != 0 then
		while 1 do
			ch = peek(ptr)
			if ch = 0 then
				exit
			end if
			st &= ch
			ptr += 1
		end while
	end if
	return st
end function

global function kisaran(object a, object min, object max)
	if (a >= min) and (a <= max) then
		return 1
	end if
	return 0
end function

global function jenisFile(object fil)
object dirfil
-- 0: file GA ADA.
-- 1: file ada
-- 2: direktori ada
	dirfil = dir(fil)
    if sequence(dirfil) then
        if find('d', dirfil[1][2]) then
            return 2
        else
            return 1
        end if
    else
        return 0
    end if
end function



