include dlla2.e
include struk.e

without warning

dllBaru("shell32", {"SHGetFileInfo", "SHGetFileInfoA"}, {cpStr, cLong, cPtr, cLong, cLong}, cLong)
--DWORD_PTRSHGetFileInfo(
--LPCTSTRpszPath,
--DWORDdwFileAttributes,
--SHFILEINFO*psfi,
--UINTcbFileInfo,
--UINTuFlags
--);

constant 
SHGFI_ATTRIBUTES         = #800    ,
SHGFI_DISPLAYNAME        = #200    ,
SHGFI_EXETYPE            = #2000   ,
SHGFI_ICON               = #100    ,
SHGFI_ICONLOCATION       = #1000   ,
SHGFI_LARGEICON          = #0      ,
SHGFI_LINKOVERLAY        = #8000   ,
SHGFI_OPENICON           = #2      ,
SHGFI_PIDL               = #8      ,
SHGFI_SELECTED           = #10000  ,
SHGFI_SHELLICONSIZE      = #4      ,
SHGFI_SMALLICON          = #1      ,
SHGFI_SYSICONINDEX       = #4000   ,
SHGFI_TYPENAME           = #400    ,
SHGFI_USEFILEATTRIBUTES  = #10     

constant 
MAX_PATH = 260

-- type SHFILEINFO
constant
SHFILEINFO_hIcon = stAdd(4),
SHFILEINFO_iIcon = stAdd(4),
SHFILEINFO_dwAttributes = stAdd(4),
SHFILEINFO_szDisplayName = stAdd(MAX_PATH),
SHFILEINFO_szTypeName = stAdd(80),
SHFILEINFO = stTotal()
-- end type

-- PENGAWAL
dllBaru("ole32", "CoInitialize", {}, cLong)
dllProc("CoInitialize", {})

include debug.e

global function shGetIcon(object nf)
object szPath, dwFileAttributes, psfi, cbFileInfo, uFlags, ret, hIcon
	debug("shGetIcon nf=" & nf)
	
	szPath = nf
	dwFileAttributes = 0
	psfi = allocate(SHFILEINFO)
	cbFileInfo = SHFILEINFO
	uFlags = SHGFI_ICON
	
	stFillZero(psfi, SHFILEINFO)

	ret = dllFunc("SHGetFileInfo", {szPath, dwFileAttributes, psfi, cbFileInfo, uFlags})
	if ret then
		hIcon = stGet(psfi, SHFILEINFO_hIcon)
	else
		hIcon = 0
	end if
	--free(psfi)
	return hIcon
end function

global function shGetType(object nf)
object pszPath, dwFileAttributes, psfi, cbFileInfo, uFlags, ret, szTypeName
	debug("shGetType nf=" & nf)
	
	pszPath = nf
	dwFileAttributes = 0
	psfi = allocate(SHFILEINFO)
	cbFileInfo = SHFILEINFO
	uFlags = SHGFI_TYPENAME
	
	stFillZero(psfi, SHFILEINFO)
	
	ret = dllFunc("SHGetFileInfo", {pszPath, dwFileAttributes, psfi, cbFileInfo, uFlags})
	if ret then
		szTypeName = sampai0(stGet(psfi, SHFILEINFO_szTypeName))
	else
		szTypeName = ""
	end if
	free(psfi)
	return szTypeName
end function

global function shGetDisplay(object nf)
object pszPath, dwFileAttributes, psfi, cbFileInfo, uFlags, ret, szDisplayName
	debug("shGetDisplay nf=" & nf)
	
	pszPath = nf
	dwFileAttributes = 0
	psfi = allocate(SHFILEINFO)
	cbFileInfo = SHFILEINFO
	uFlags = SHGFI_DISPLAYNAME
	
	stFillZero(psfi, SHFILEINFO)
	
	ret = dllFunc("SHGetFileInfo", {pszPath, dwFileAttributes, psfi, cbFileInfo, uFlags})
	if ret then
		szDisplayName = sampai0(stGet(psfi, SHFILEINFO_szDisplayName))
	else
		szDisplayName = ""
	end if
	free(psfi)
	return szDisplayName
end function

